//
//  BaiduCommonAPIViewController.m
//  BaiduSDKDemo
//
//  Created by user1 on 12-10-24.
//  Copyright (c) 2012年 baidu open platform. All rights reserved.
//

#import "BaiduCommonAPIViewController.h"

@interface BaiduCommonAPIViewController ()

@end

@implementation BaiduCommonAPIViewController
@synthesize urlText = _urlText;
@synthesize httpMethodText = _httpMethodText;
@synthesize resultView = _resultView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        self.tabBarItem = [[[UITabBarItem alloc] initWithTitle:@"普通API" image:nil tag:0] autorelease];
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.urlText.text = @"https://openapi.baidu.com/rest/2.0/passport/users/getLoggedInUser";
    self.httpMethodText.text = @"GET";
    
    if ([[UIDevice currentDevice].systemVersion floatValue] >= 7.0) {
        [self setEdgesForExtendedLayout:UIRectEdgeNone];
    }
    
    UIBarButtonItem *leftbarButtonItem = [[UIBarButtonItem alloc]initWithTitle:@"登出" style:UIBarButtonItemStylePlain target:self action:@selector(userLogout:)];
	self.navigationItem.leftBarButtonItem = leftbarButtonItem;
	[leftbarButtonItem release];
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)dealloc
{
    self.urlText = nil;
    self.httpMethodText = nil;
    self.resultView = nil;
    [super dealloc];
}

-(IBAction)apiTest:(id)sender
{
    [BaiduOAuthSDK apiRequestWithUrl:self.urlText.text httpMethod:self.httpMethodText.text params:nil andDelegate:self];
}

-(IBAction)backgroundClick:(id)sender
{
    [self.urlText resignFirstResponder];
    [self.httpMethodText resignFirstResponder];
}

- (void)userLogout:(id)sender
{
    [BaiduOAuthSDK currentUserLogout];
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)apiRequestDidFinishLoadWithResult:(id)result
{
    NSMutableString *resultStr = [NSMutableString stringWithFormat:@""];
    if ([result isKindOfClass:[NSDictionary class]]) {
        NSDictionary *resultDic = (NSDictionary *)result;
        for (NSString *key in [resultDic keyEnumerator]) {
            [resultStr appendFormat:@"%@:%@\n",key,[resultDic objectForKey:key]];
        }
    } else {
        NSArray *resultArr = (NSArray *)result;
        for (NSDictionary *resultItem in resultArr) {
            for (NSString *key in [resultItem keyEnumerator]) {
                [resultStr appendFormat:@"%@:%@\n",key,[resultItem objectForKey:key]];
            }
        }
    }
    self.resultView.text = resultStr;
    return;
}
- (void)apiRequestDidFailLoadWithError:(NSError*)error
{
    UIAlertView *alertView = [[[UIAlertView alloc] initWithTitle:@"授权提示" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil] autorelease];
    [alertView show];
    return;
}


@end
