//
//  BaiduSDKDemoViewController.m
//  BaiduSDKDemo
//
//  Created by user1 on 11-12-27.
//  Copyright (c) 2011年 baidu open platform. All rights reserved.
//

#import "BaiduSDKDemoViewController.h"
#import "BaiduCommonAPIViewController.h"

@interface BaiduSDKDemoViewController ()

- (void)alreadyLogin;

@end

@implementation BaiduSDKDemoViewController
@synthesize authButton = _authButton;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    [BaiduOAuthSDK initWithAPIKey:@"7TjGqkwAU5rQPcC6LKGMjpKd" appId:@"2014185"];
    
    self.title = @"用户授权";
    
    if ([self respondsToSelector:@selector(setEdgesForExtendedLayout:)]) {
        [self setEdgesForExtendedLayout:UIRectEdgeNone];
    }
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
}

-(IBAction)doUserLogin:(id)sender
{
    if ([BaiduOAuthSDK isUserTokenValid]) {
        [self alreadyLogin];
    } else {
        [BaiduOAuthSDK authorizeWithTargetViewController:self scope:@"basic,super_msg,netdisk,pcs_doc,pcs_video" andDelegate:self];
    }
}

-(IBAction)doUserRegister:(id)sender
{
    [BaiduOAuthSDK registerWithTargetViewController:self scope:@"basic,super_msg,netdisk,pcs_doc,pcs_video" andDelegate:self];
}

-(IBAction)doUserSmsLogin:(id)sender
{
    if ([BaiduOAuthSDK isUserTokenValid]) {
        [self alreadyLogin];
    } else {
        [BaiduOAuthSDK smsAuthWithTargetViewController:self scope:@"basic,super_msg,netdisk,pcs_doc,pcs_video" andDelegate:self];
    }

}

- (void)loginDidSuccessWithTokenInfo:(BaiduTokenInfo *)tokenInfo
{
    NSLog(@"access_token:%@,\nexpire_time:%@,\nscope:%@",tokenInfo.accessToken,tokenInfo.expiresIn, tokenInfo.scope);
    [self alreadyLogin];
}

- (void)alreadyLogin
{
    BaiduCommonAPIViewController *viewController = nil;
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        viewController = [[BaiduCommonAPIViewController alloc] initWithNibName:@"BaiduCommonAPIViewController_iPhone" bundle:nil];
    } else {
        viewController = [[BaiduCommonAPIViewController alloc] initWithNibName:@"BaiduCommonAPIViewController_iPad" bundle:nil];
    }
    
    [self.navigationController pushViewController:viewController animated:YES];
    [viewController release];
}

- (void)loginDidCancel
{
    UIAlertView *alertView = [[[UIAlertView alloc] initWithTitle:@"授权提示" message:@"授权取消" delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil] autorelease];
    [alertView show];
}

- (void)loginFailedWithError:(NSError*)error
{
    UIAlertView *alertView = [[[UIAlertView alloc] initWithTitle:@"授权提示" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil] autorelease];
    [alertView show];
}
#pragma mark -Authorization Code 授权方式登录
- (IBAction)doUserAuthCodeLogin:(id)sender {
     [BaiduOAuthSDK initWithAPIKey:@"ASScu4RtVH2iFiDxf035rfN2" appId:@"3183406"];
     [BaiduOAuthSDK authorizationCodeWithTargetViewController:self scope:@"basic,super_msg,netdisk,pcs_doc,pcs_video" redirctUrl:@"http://x.baidu.com/plug-in-services/demo/easysleepdiary/auth.php" needSignUp:YES andDelegaet:self];
}

- (IBAction)doGetAuthCodeBySms:(id)sender {
      
    [BaiduOAuthSDK initWithAPIKey:@"ASScu4RtVH2iFiDxf035rfN2" appId:@"3183406"];
    [BaiduOAuthSDK smsAuthCodeWithTargetViewController:self
                                                 scope:@"basic,super_msg,netdisk,pcs_doc,pcs_video"
                                                mobile:@""
                                            redirctUrl:@"http://x.baidu.com/plug-in-services/demo/easysleepdiary/auth.php"
                                            needSignUp:NO
                                           andDelegate:self];
}

#pragma mark -获取Authorization Code成功
- (void)authorizationCodeSuccessWithCode:(NSString *)code
{
    NSString *message = [NSString stringWithFormat:@"Authorization Code 是 %@",code];
    UIAlertView *alertView = [[[UIAlertView alloc] initWithTitle:@"授权提示" message:message delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil] autorelease];
    [alertView show];
    
}

- (void)authorizationCodeWithError:(NSError*)error
{
    UIAlertView *alertView = [[[UIAlertView alloc] initWithTitle:@"授权提示" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"确定" otherButtonTitles:nil] autorelease];
    [alertView show];
}
- (void)dealloc
{
    self.authButton = nil;
    [super dealloc];
}

@end
